#
# Delayed function call class by moveq
# Copyright (C) 2007-2008 moveq / Suomipoeka team (suomipoeka@gmail.com)
# In case of reuse of this source code please do not remove this copyright.
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	For more information on the GNU General Public License see:
#	<http://www.gnu.org/licenses/>.
#

from enigma import eTimer
from SuomipoekaTasker import spDebugOut

timers = [ [eTimer(), True], [eTimer(), True], [eTimer(), True], [eTimer(), True], [eTimer(), True] ]

class DelayedFunction:
	def __init__(self, delay, function, p1="!", p2="!", p3="!", p4="!"):
		try:
			self.function = function
			self.p1 = p1
			self.p2 = p2
			self.p3 = p3
			self.p4 = p4
			self.timer = None
			for t in timers:
				if t[1] == True:
					t[1] = False
					self.timer = t[0]
					break
			if self.timer is not None:
				self.timer.timeout.get().append(self.timerLaunch)
				self.timer.start(delay, False)
			else:
				spDebugOut("[spDF] no timer!")

		except Exception, e:
			spDebugOut("[spDF] __init__ exception:\n" + str(e))

	def timerLaunch(self):
		try:
#			spDebugOut("[spDF] call: " + str(self.function))
			self.timer.stop()
			self.timer.timeout.get().remove(self.timerLaunch)
			for t in timers:
				if t[0] == self.timer:
					t[1] = True
					break
			self.timer = None
			if self.p1 == "!":
				self.function()
			elif self.p2 == "!":
				self.function(self.p1)
			elif self.p3 == "!":
				self.function(self.p1, self.p2)
			elif self.p4 == "!":
				self.function(self.p1, self.p2, self.p3)
			else:
				self.function(self.p1, self.p2, self.p3, self.p4)
		except Exception, e:
			spDebugOut("[spDF] timerLaunch exception:\n" + str(e))

