#
# Suomipoeka plugin by moveq
# Copyright (C) 2007-2008 moveq / Suomipoeka team (suomipoeka@gmail.com)
# In case of reuse of this source code please do not remove this copyright.
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	For more information on the GNU General Public License see:
#	<http://www.gnu.org/licenses/>.
#
from Plugins.Plugin import PluginDescriptor
from Components.config import *
from Components.Language import language
from SuomipoekaTasker import spTasker, spDebugOut
from Suomipoeka import _, localeInit, SuomipoekaVersion, suomipoekaStartup, SuomipoekaMenu

def langList():
	newlist = []
	for e in language.getLanguageList():
		newlist.append( (e[0], _(e[1][0])) )
	return newlist

config.suomipoeka = ConfigSubsection()
config.suomipoeka.about = ConfigSelection(default = "1", choices = [("1", " ")])
config.suomipoeka.extmenu_plugin = ConfigYesNo()
config.suomipoeka.extmenu_list = ConfigYesNo()
config.suomipoeka.epglang = ConfigSelection(default = language.getActiveLanguage(), choices = langList() )
config.suomipoeka.dialog_transparency = ConfigInteger(default = 30, limits = (0,99))
config.suomipoeka.key_period = ConfigInteger(default = 100, limits = (30,900))
config.suomipoeka.key_repeat = ConfigInteger(default = 500, limits = (250,900))
config.suomipoeka.enigmarestart = ConfigYesNo(default = True)
config.suomipoeka.enigmarestart_begin = ConfigClock(default = 60*60*2)
config.suomipoeka.enigmarestart_end = ConfigClock(default = 60*60*5)
config.suomipoeka.enigmarestart_stby = ConfigYesNo()
config.suomipoeka.debug = ConfigYesNo()
config.suomipoeka.debugfile = ConfigText(default = "output.txt", fixed_size = False, visible_width = 22)
config.suomipoeka.nptd_init = ConfigYesNo()
config.suomipoeka.nptd_serv = ConfigText(default = "fi.pool.ntp.org", fixed_size = False, visible_width = 22)
config.suomipoeka.movie_bluefunc = ConfigSelection(default = "Movie home", choices = [("Movie home", _("Movie home")), ("Play last", _("Play last"))])
config.suomipoeka.movie_descdis = ConfigYesNo()
config.suomipoeka.movie_descdelay = ConfigInteger(default = 200, limits = (10,999))
config.suomipoeka.movie_dateleft = ConfigYesNo()
config.suomipoeka.movie_icons = ConfigYesNo(default = True)
config.suomipoeka.movie_mark = ConfigYesNo(default = True)
config.suomipoeka.movie_metaload = ConfigYesNo(default = True)
config.suomipoeka.movie_reopen = ConfigYesNo()
config.suomipoeka.movie_reload = ConfigYesNo()
config.suomipoeka.movie_defpath = ConfigText(default = "/hdd/movie", fixed_size = False, visible_width = 22)
config.suomipoeka.movie_homepath = ConfigText(default = "/hdd/movie", fixed_size = False, visible_width = 22)
config.suomipoeka.movie_pathlimit = ConfigText(default = "/hdd/movie", fixed_size = False, visible_width = 22)
config.suomipoeka.movie_trashpath = ConfigText(default = "/hdd/movie/.trashcan", fixed_size = False, visible_width = 22)
config.suomipoeka.movie_trashcan_hide = ConfigYesNo()
config.suomipoeka.movie_trashcan_limit = ConfigInteger(default = 7, limits = (0,999))
config.suomipoeka.movie_hide_mov = ConfigYesNo()
config.suomipoeka.movie_hide_del = ConfigYesNo()
config.suomipoeka.movie_perm = ConfigYesNo(default = True)
config.suomipoeka.movie_perm_val = ConfigInteger(default = 755, limits = (0,777))
config.suomipoeka.movielist_reversed = ConfigYesNo()
config.suomipoeka.movielist_gotonewest = ConfigYesNo()
config.suomipoeka.movielist_gotonewestp = ConfigYesNo()
config.suomipoeka.movielist_selmove = ConfigYesNo(default = True)
config.suomipoeka.player_seek = ConfigInteger(default = 180, limits = (100,900))
config.suomipoeka.player_seekchg = ConfigInteger(default = 60, limits = (10,100))
config.suomipoeka.autochange_cifs = ConfigSelection(default = "u", choices = [("u", _("unhide")), ("d", _("delete")), ("n", _("do nothing"))])
config.suomipoeka.timer_delq = ConfigYesNo(default = True)
config.suomipoeka.timer_clnq = ConfigYesNo(default = True)
config.suomipoeka.timer_autocln = ConfigYesNo()
config.suomipoeka.rec_start_notify = ConfigYesNo()

launch_choices = [	("None", _("No override")),
					("showMovies", _("Video-button")),
					("showTv", _("TV-button")),
					("showRadio", _("Radio-button")),
					("openQuickbutton", _("Quick-button")),
					("timeshiftStart", _("Timeshift-button"))]
config.suomipoeka.movie_launch = ConfigSelection(default = "showMovies", choices = launch_choices)

gSession = None
gRecordings = None

def showMoviesNew(dummy_self = None):
	try:
		global gSession
		global gRecordings
		gSession.execDialog(gRecordings)
	except Exception, e:
		spDebugOut("[showMoviesNew] exception:\n" + str(e))

def autostart(reason, **kwargs):
	if reason == 0: # start
		if kwargs.has_key("session"):
			global gSession
			gSession = kwargs["session"]

			suomipoekaStartup(gSession)
			spTasker.Initialize(gSession)

			try:
				from Screens.InfoBar import InfoBar
				value = config.suomipoeka.movie_launch.value
				if value == "showMovies":			InfoBar.showMovies = showMoviesNew
				elif value == "showTv":				InfoBar.showTv = showMoviesNew
				elif value == "showRadio":			InfoBar.showRadio = showMoviesNew
				elif value == "openQuickbutton":	InfoBar.openQuickbutton = showMoviesNew
				elif value == "timeshiftStart":		InfoBar.startTimeshift = showMoviesNew
			except Exception, e:
				spDebugOut("[spStartup] MovieList launch override exception:\n" + str(e))

			try:
				global gRecordings
				from MovieSelection import MovieSelectionSP
				gRecordings = gSession.instantiateDialog(MovieSelectionSP)
			except Exception, e:
				spDebugOut("[spStartup] instantiateDialog exception:\n" + str(e))

def pluginOpen(session, **kwargs):
	try:
		session.open(SuomipoekaMenu)
	except Exception, e:
		spDebugOut("[pluginOpen] exception:\n" + str(e))

def recordingsOpen(session, **kwargs):
	showMoviesNew()

def Plugins(**kwargs):
	localeInit()
	descriptors = [PluginDescriptor(where = PluginDescriptor.WHERE_SESSIONSTART, fnc = autostart)]

	show_p = [ PluginDescriptor.WHERE_PLUGINMENU ]
	if config.suomipoeka.extmenu_plugin.value:
		show_p.append( PluginDescriptor.WHERE_EXTENSIONSMENU )

	descriptors.append( PluginDescriptor(name = "Suomipoeka "+SuomipoekaVersion, description = "Suomipoeka " +_("configuration"), icon = "Suomipoeka.png", where = show_p, fnc = pluginOpen) )

	if config.suomipoeka.extmenu_list.value:
		descriptors.append( PluginDescriptor(name = "Suomipoeka MovieList", description = "Suomipoeka " + _("movie manipulation list"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc = recordingsOpen) )
	return descriptors

